#!/bin/sh

SCRIPTNAME=$0

if [ $# -ge 3 ]
then
  :
else
  echo "$0: Insufficient number of arguments." 1>&2
  exit 1
fi

TEMPFILE=$1
PROPSFILE=$3
CEA_GENACT_DEBUG_LOG=../log/${PROPSFILE}.log
CEA_GENACT_AUX_SCRIPT=../bin/get-uis-thru-posix-api
echo "(`date`) CeA/ExtendIT Debug Log created by $SCRIPTNAME on `hostname` (`uname`)." > $CEA_GENACT_DEBUG_LOG

RETVAL_PPC=`uname -i | grep "ppc"`
RETVAL_POWERPC=`uname -i | grep "powerpc"`
if [[ ! -z ${RETVAL_PPC} || ! -z ${RETVAL_POWERPC} ]]
then
  CEA_GENACT_AUX_SCRIPT="${CEA_GENACT_AUX_SCRIPT}-ppc"
fi

# zLinux ESes porting: TSIEM00016618 {
RETVAL_Z=`uname -i | grep "s390"`
if [[ ! -z ${RETVAL_Z} ]]
then
  CEA_GENACT_AUX_SCRIPT="${CEA_GENACT_AUX_SCRIPT}-zlinux"
fi
# }

if [[ ! -x ${CEA_GENACT_AUX_SCRIPT} && ! -r ${CEA_GENACT_AUX_SCRIPT} ]]
then
  echo "Error. Do not have executable access on ${CEA_GENACT_AUX_SCRIPT}." >> $CEA_GENACT_DEBUG_LOG
  echo "(`date`) CeA/ExtendIT Debug Log finished by $SCRIPTNAME on `hostname` (`uname`) after FAILED collect attempt." >> $CEA_GENACT_DEBUG_LOG
  exit 1
fi

CEA_COMMAND="${CEA_GENACT_AUX_SCRIPT} ${TEMPFILE}"
echo "(`date`) Retrieving the user information (${CEA_COMMAND})... " >> $CEA_GENACT_DEBUG_LOG
${CEA_COMMAND} >> $CEA_GENACT_DEBUG_LOG 2>>${CEA_GENACT_DEBUG_LOG}
if [ $? -ne 0 ]
then
  echo "(`date`) Error retrieving the user information." >> $CEA_GENACT_DEBUG_LOG
  echo "(`date`) CeA/ExtendIT Debug Log finished by $SCRIPTNAME on `hostname` (`uname`) after FAILED collect attempt." >> $CEA_GENACT_DEBUG_LOG
fi
echo "(`date`) Retrieving the user information. Done." >> $CEA_GENACT_DEBUG_LOG
echo "(`date`) CeA/ExtendIT Debug Log finished by $SCRIPTNAME on `hostname` (`uname`) after SUCCESSFUL collect." >> $CEA_GENACT_DEBUG_LOG
