#!/bin/sh

cea_exit()
{
  debug "$1 `date`"
  echo "CeA/ExtendIT Debug Log finished by $SCRIPTNAME on `hostname` (`uname`) after FAILED collect for the to-be-mapped sublog, `date`." >> $CEA_GENACT_DEBUG_LOG
  rm -f ${TEMPFILE1}
  rm -f ${TEMPFILE2}
  rm -f ${PROPSFILE}_2
  rm -f ${CEA_GENACT_DEBUG_LOG}_2
  exit $2
}

export LC_TIME="C"

CEA_AUSEARCH="/sbin/ausearch"
CEA_GENACT_DEBUG_LOG=../log/${PROPSFILE}.log
source ${CEA_GENACT_FUNCLIB} || exit 1

[[ ! -r "${TEMPFILE1}" ]] && cea_exit "The original sublog does not exist." "200"

if [[ -x ${CEA_AUSEARCH} && -r ${CEA_AUSEARCH} ]]
then
  debug "Have executable access on ${CEA_AUSEARCH}, sudo will not be used."
  CEA_SUDO=""
else
  debug "Do not have executable access on ${CEA_AUSEARCH}, sudo will be used."
  CEA_SUDO="sudo"
fi

CEA_COMMAND="${CEA_SUDO} ${CEA_AUSEARCH} --interpret --input ${TEMPFILE1}"
debug "Retrieving the interpreted dump from the original sublog ($CEA_COMMAND). `date`"
${CEA_COMMAND}>${TEMPFILE2} 2>${CEA_GENACT_DEBUG_LOG}_2
if [ $? -ne 0 ]
then
  NOMATCHES=`grep "<no matches>" ${CEA_GENACT_DEBUG_LOG}_2`
  cat ${CEA_GENACT_DEBUG_LOG}_2>>${CEA_GENACT_DEBUG_LOG}
  [[ -z "${NOMATCHES}" ]] && cea_exit "Error executing ${CEA_AUSEARCH}. `date`" "201"
fi
rm -f ${CEA_GENACT_DEBUG_LOG}_2
debug "${CEA_AUSEARCH} execution finished with return code \"$?\". `date`"

cat ${PROPSFILE}_2>${PROPSFILE} 2>>${CEA_GENACT_DEBUG_LOG}
rm -f ${PROPSFILE}_2
echo "CeA/ExtendIT Debug Log finished by $SCRIPTNAME on `hostname` (`uname`) after SUCCESSFUL collect for the to-be-mapped sublog, `date`." >> $CEA_GENACT_DEBUG_LOG
