@echo off
set TEMPFILE1=%~1
set TEMPFILE2=%~2
set TEMPFILE3=%~3
set DBTYPE=%~4
set DBNAME=%~5
set DBSCHEMA=%~6
set PORT=%~7
set USERNAME=%~8
set PASSWORD=%~9
for %%I in (%*) do set PROPSFILE=%%~I
for %%I in (%PROPS_FILE%) do set PROPS_NAME=%%~nI

if "%PROPSFILE%" == "" (
   set ES_LOG="..\log\gettamessologs.err"
) else (
   set ES_LOG="..\log\%PROPS_NAME%.log"
)

echo [%date% %time%] Processing started.> %ES_LOG%

if "%TEMPFILE1%" == "" (
    echo [%date% %time%] ERROR: temporary file 1 location is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

if "%TEMPFILE2%" == "" (
    echo [%date% %time%] ERROR: temporary file 2 location is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

if "%TEMPFILE3%" == "" (
    echo [%date% %time%] ERROR: temporary file 3 location is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

rem defining DBHOST
for /F "tokens=1,2 delims='='" %%i in (%PROPSFILE%) do ( 
   if "%%i"=="SystemName" (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     )
     
   if "%%i"=="SystemName " (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     ) 
   )
   
if "%DBHOST%" == "" (
    echo [%date% %time%] ERROR: Database host is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)
echo %DBHOST% | findstr /R "[!()\/@*&$*]" > nul
if %ERRORLEVEL% EQU 0 (
    echo [%date% %time%] ERROR: Hostname contains illegal characters.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

if "%PORT%" == "" (
    echo [%date% %time%] ERROR: Database host is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)
echo %PORT% | findstr /R "[!()\/@*&$*A-Za-z]" > nul
if %ERRORLEVEL% EQU 0 (
    echo [%date% %time%] ERROR: Port contains illegal characters.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

if "%DBNAME%" == "" (
    echo [%date% %time%] ERROR: Database name is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

if "%USERNAME%" == "" (
    echo [%date% %time%] ERROR: User name is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

if "%DBSCHEMA%" == "" (
    echo [%date% %time%] ERROR: Database schema is not specified.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

set DBTYPE_OK=0
if "%DBTYPE%" == "DB2" (
    echo [%date% %time%] Database type is %DBTYPE%.>> %ES_LOG%
    set DBTYPE_OK=1
)
if "%DBTYPE%" == "Oracle" (
    echo [%date% %time%] Database type is %DBTYPE%.>> %ES_LOG%
    set DBTYPE_OK=1
)
if "%DBTYPE%" == "MS SQL" (
    echo [%date% %time%] Database type is %DBTYPE%.>> %ES_LOG%
    set DBTYPE_OK=1
)
if "%DBTYPE_OK%" == "0" (
    echo [%date% %time%] Wrong database type is specified. Using DB2 by default.>> %ES_LOG%
    set DBTYPE=DB2
)

echo [%date% %time%] Checking Java binary availability.>> %ES_LOG%
where java > nul 2>&1
if %ERRORLEVEL% EQU 1 (
    echo [%date% %time%] ERROR: Java binary is not found.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

echo SELECT * FROM %DBSCHEMA%.IMSLOGUserActivity > IMSLOGUserActivity_%PROPSFILE%.sql
echo SELECT * FROM %DBSCHEMA%.IMSLOGUserAdminActivity > IMSLOGUserAdminActivity_%PROPSFILE%.sql
echo SELECT * FROM %DBSCHEMA%.IMSLOGUserService > IMSLOGUserService_%PROPSFILE%.sql

if "%JDBCDRIVERPATH%"=="" (
 echo [%date% %time%] Location of JDBC driver is not defined. Trying to use default. >> %ES_LOG%
 dir /b ..\..\*.jar > jarlist_%PROPSFILE%.tmp
 if %ERRORLEVEL% EQU 0 (
     for /F %%i in ('type jarlist_%PROPSFILE%.tmp') do (
       call :init_jdbc ../../%%i
     )
   )
del /Q jarlist_%PROPSFILE%.tmp
)

set COLLECT_SUCCESSFUL=1
echo [%date% %time%] Collecting IMSLOGUserActivity table.>> %ES_LOG%
..\bin\cmtool.exe -k -d %PASSWORD% | java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" com.ibm.tcim.cea.gensub.jdbcgenact.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="" -props="%PROPSFILE%" -outfilename="%TEMPFILE1%" -sqlfilename="IMSLOGUserActivity_%PROPSFILE%.sql" -useheaderline=yes -stdinpassword=yes -separator=";" -eraseoutfile=yes -tdcolumn=logTime >>%ES_LOG% 2>&1
if not errorlevel 1 (
    set COLLECT_SUCCESSFUL=0
)

echo [%date% %time%] Collecting IMSLOGUserAdminActivity table.>> %ES_LOG%
..\bin\cmtool.exe -k -d %PASSWORD% | java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" com.ibm.tcim.cea.gensub.jdbcgenact.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="" -props="%PROPSFILE%" -outfilename="%TEMPFILE2%" -sqlfilename="IMSLOGUserAdminActivity_%PROPSFILE%.sql" -useheaderline=yes -stdinpassword=yes -separator=";" -eraseoutfile=yes -tdcolumn=logTime >>%ES_LOG% 2>&1
if not errorlevel 1 (
    set COLLECT_SUCCESSFUL=0
)

echo [%date% %time%] Collecting IMSLOGUserService table.>> %ES_LOG%
..\bin\cmtool.exe -d %PASSWORD% | java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" com.ibm.tcim.cea.gensub.jdbcgenact.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="" -props="%PROPSFILE%" -outfilename="%TEMPFILE3%" -sqlfilename="IMSLOGUserService_%PROPSFILE%.sql" -useheaderline=yes -stdinpassword=yes -separator=";" -eraseoutfile=yes -tdcolumn=logTime >>%ES_LOG% 2>&1
if not errorlevel 1 (
    set COLLECT_SUCCESSFUL=0
)

if %COLLECT_SUCCESSFUL% EQU 1 (
    echo [%date% %time%] ERROR: None of the tables are collected succsessfully.>> %ES_LOG%
    echo [%date% %time%] Processing finished [FAILURE].>> %ES_LOG%
    exit /b 1
)

echo [%date% %time%] Clearing temporary files.>> %ES_LOG%
del IMSLOGUserActivity_%PROPSFILE%.sql
del IMSLOGUserAdminActivity_%PROPSFILE%.sql
del IMSLOGUserService_%PROPSFILE%.sql

echo [%date% %time%] Processing finished [SUCCESS].>> %ES_LOG%
exit /b 0


:init_jdbc
set JDBCDRIVERPATH=%JDBCDRIVERPATH%;%~1
exit /b
