#!/bin/ksh

if [ -z "$1" -o -z "$2" ]; then
    exit 1
fi

HOST_NAME=$1
PROPS_FILE=$2
TEMP_PROPS=${PROPS_FILE}-tmp

if [ -z "$LANG" ]; then
   # if LANG variable is not defined, defaults to English
   TLANGUAGE=en
   TENCODING=ISO-8859-1
else
   # splitting data into variables
   `echo $LANG | awk -F"." '{ print "export TLANGUAGE="$1" TENCODING="toupper($2) }'`
fi

# writing results to properties file excluding previous values
sed -e '
   /^[ 	]*agentlanguage[ 	]*=.*$/d;
   /^[ 	]*agentencoding[ 	]*=.*$/d;
   /^[ 	]*LANG[ 	]*=.*$/d;
   /^[ 	]*$/d
' "$PROPS_FILE" > "$TEMP_PROPS" 2>/dev/null

echo "">> "$TEMP_PROPS"
echo "agentlanguage = $TLANGUAGE">> "$TEMP_PROPS"
echo "agentencoding = $TENCODING">> "$TEMP_PROPS"
echo "LANG = $LANG">> "$TEMP_PROPS"
cat "$TEMP_PROPS" > "$PROPS_FILE"
rm -f "$TEMP_PROPS"

exit 0
