#!/bin/sh
# Generated file
# Licensed Materials - Property of IBM
# 5724-S67
# (c) Copyright IBM Corp. 1998, 2012   All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
ERR_ALR_RUN=10
ERR_EXC_TERM=11
LPI=$1
shift 1
L=$1
shift 1
SCRIPT=$1
RUN=1
if [ -f ../$LPI/run/pid ]; then
   PID=`cat ../$LPI/run/pid`
   status=`ps -ef | grep -v grep | grep $PID | awk '{print $9 $10}' | grep ${SCRIPT}`
   if [ -n "$status" ]; then
      mkdir run
      echo "$ERR_ALR_RUN" > run/$LPI.SSHwrap.log
      echo "Collect script is already run" >>run/$LPI.SSHwrap.log
      exitCode=$ERR_ALR_RUN
      RUN=0
   else
      return_code=`head -n 1 ../$LPI/run/$LPI.SSHwrap.log`
      if [ $return_code -eq 0 ]; then
         cd ..
         rm -fr $LPI.start
         cd $LPI
         exitCode=0
         RUN=0
      fi
   fi
fi
if [ $RUN -eq 1 ]; then
   cd ..
   [ -x $LPI ] && rm -r $LPI
   mv $LPI.start $LPI
   cd $LPI
   mkdir run log bin
   chmod +rw run log bin
   chmod +x bin/*
   [ -d run/pipes ] && chmod 700 run/pipes
   mv bin/libicudata40.1.a.aix bin/libicudata40.1.a
   mv bin/libicudata40.a.aix bin/libicudata40.a
   mv bin/libicudata.a.aix bin/libicudata.a
   mv bin/libicui18n40.1.a.aix bin/libicui18n40.1.a
   mv bin/libicui18n40.a.aix bin/libicui18n40.a
   mv bin/libicui18n.a.aix bin/libicui18n.a
   mv bin/libicuio40.1.a.aix bin/libicuio40.1.a
   mv bin/libicuio40.a.aix bin/libicuio40.a
   mv bin/libicuio.a.aix bin/libicuio.a
   mv bin/libicule40.1.a.aix bin/libicule40.1.a
   mv bin/libicule40.a.aix bin/libicule40.a
   mv bin/libicule.a.aix bin/libicule.a
   mv bin/libiculx40.1.a.aix bin/libiculx40.1.a
   mv bin/libiculx40.a.aix bin/libiculx40.a
   mv bin/libiculx.a.aix bin/libiculx.a
   mv bin/libicutu40.1.a.aix bin/libicutu40.1.a
   mv bin/libicutu40.a.aix bin/libicutu40.a
   mv bin/libicutu.a.aix bin/libicutu.a
   mv bin/libicuuc40.1.a.aix bin/libicuuc40.1.a
   mv bin/libicuuc40.a.aix bin/libicuuc40.a
   mv bin/libicuuc.a.aix bin/libicuuc.a
   mv bin/goBackInTime.aix bin/goBackInTime
   mv bin/goBackInTimeSimple.aix bin/goBackInTimeSimple
   cd run
   shift 1
   echo "$ERR_EXC_TERM" > $LPI.SSHwrap.log
   echo "Execution was terminated" >>$LPI.SSHwrap.log
   nohup "$SCRIPT" "$@" > ../log/$LPI.SSHcollect.log & 
   echo $! > pid
   wait $!
   ERROR=$?
   [ -d pipes ] && rm -f pipes/*
   echo $ERROR > $LPI.SSHwrap.log
   if [ $ERROR -eq 0 ]; then
      echo "success" >> $LPI.SSHwrap.log
   else
      echo "error" >> $LPI.SSHwrap.log
   fi
   exitCode=0
   cd ..
fi
cd run
tar -cf - $LPI.props.failedlogin.idx $LPI.props.failedlogin.val $LPI.props.wtmp.idx $LPI.props.wtmp.val $LPI.props ../log/*.log *.tmp $LPI.SSHwrap.log | gzip -9 -c -f
cd ../..
[ "$exitCode" -eq 0 ] && mv $LPI $LPI$L.previous
