@echo off
REM Generated file
REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2012   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

REM set default values
set SCRIPT_FULL_NAME=%~dpnx0
set SCRIPT_NAME=%0
set ERR_ALR_RUN=10
set ERR_EXC_TERM=11

if %1 EQU aftermove goto aftermove

REM catch command line parameters
set LPI=%1
set LOG_FILE=run\%LPI%.SSHwrap.log
type nul > %LOG_FILE%
call :print_message "Collect started by: %SCRIPT_FULL_NAME%"
shift
set L=%1
shift
set SCRIPT=%1

REM skip first 3 input params: LPI, L, SCRIPT
REM all other are parameters goes to collect script
call :print_message "Processing collect script arguments"
set PARAMS=
for /f "tokens=3,*" %%i in ("%*") do set PARAMS=%%j

REM replace escaped quotes (\") with normal quotes (")
set PARAMS=%PARAMS:\"="%
set SCRIPT=%SCRIPT:\"="%
set L=%L:\"=%
set L=%L:"=%
if "%L%" == "NONE" (set L=)

REM PID checking
call :print_message "Starting PID check"

REM get current process PID
set PID_CMD=tasklist /FI "IMAGENAME eq cmd.exe" /FO TABLE /NH
%PID_CMD% > run\%LPI%.pidlist
set PID=0
for /f "tokens=2" %%i in (run\%LPI%.pidlist) do set PID=%%i
del /Q run\%LPI%.pidlist
call :print_message "Current process PID: %PID%"

REM check PID file existense (previous collect)
set PID_FILE=..\%LPI%\run\pid
if exist %PID_FILE% (
   call :print_message "PID file found [previous collect]"
   call :check_old_pid
) else (
   call :print_message "Previous collect finished, OK"
)

REM process collect
cd ..
rmdir /S /Q %LPI%
move /Y %LPI%.start %LPI% > nul && call %LPI%\%SCRIPT_NAME% aftermove
echo ^1> %LOG_FILE%
call :print_message "ERROR: resurrection failed after move"
exit 1

:aftermove
cd %LPI%
call :print_message "Resurrected after move"
mkdir run log bin
move /Y bin\jdbc-genact.jar.nt bin\jdbc-genact.jar > nul
move /Y bin\cmtool.exe.nt bin\cmtool.exe > nul
echo %PID%> %PID_FILE%
cd run

REM launch execution
set LOG_FILE=%LPI%.SSHwrap.log
echo %ERR_EXC_TERM%> %LOG_FILE%
call :print_message "Execution was terminated"
call %SCRIPT% %PARAMS%
if NOT errorlevel 1 (
   echo ^0> %LOG_FILE%
   echo success>> %LOG_FILE%
) else (
   echo ^1> %LOG_FILE%
   echo error>> %LOG_FILE%
   exit %errorlevel%
)

REM finish processing (success)
del /Q pipes\* ..\%PID_FILE%
..\..\bsdtar.exe -czf - ..\log\*.log %LPI%.props *.tmp *.log
cd ..\..
move /Y %LPI% %LPI%%L%.previous > nul
exit 0

:check_old_pid
set /P OLD_PID=<%PID_FILE%
call :print_message "Previous collect PID: %OLD_PID%"
%PID_CMD% > run\%LPI%.pidlist2
for /f "tokens=2" %%i in (run\%LPI%.pidlist2) do (
    if "%%i" EQU "%OLD_PID%" (
       call :still_run
    ) else (
       call :not_run
    )
)
del /Q run\%LPI%.pidlist2
exit /b

:still_run
echo %ERR_ALR_RUN%> %LOG_FILE%
call :print_message "ERROR: Previous collect still run"
exit %ERR_ALR_RUN%

:not_run
set /P ERR_CODE=< ..\%LPI%\%LOG_FILE%
if %ERR_CODE% EQU 0 (
   del /Q %PID_FILE%
   cd ..
   rmdir /S /Q %LPI%.start
   cd %LPI%
   exit 0
)
exit /b

:print_message
echo [%date%] [%time%] %~1>> %LOG_FILE%
exit /b
